<!-- 
{{- $page := .page }}
{{- $menuID := .menuID }}
-->

<!-- {{- with index site.Menus $menuID }} -->
<aside class="w-64 h-screen transition-transform -translate-x-full sm:translate-x-0" aria-label="Sidebar">
  <div class="h-full px-2 py-4 overflow-y-auto">
     <ul class="space-y-2 font-medium">
        {{- partial "inline/menu/walk.html" (dict "page" $page "menuEntries" .) }}
     </ul>
  </div>
</aside>
<!-- {{- end }} -->

{{- define "partials/inline/menu/walk.html" }}
  {{- $page := .page }}
  {{- range .menuEntries }}
    <!-- 
    {{- $attrs := dict "href" .URL }}
    {{- if $page.IsMenuCurrent .Menu . }}
      {{- $attrs = merge $attrs (dict "class" "active" "aria-current" "page") }}
    {{- else if $page.HasMenuCurrent .Menu .}}
      {{- $attrs = merge $attrs (dict "class" "ancestor" "aria-current" "true") }}
    {{- end }}
    {{- $name := .Name }}
    {{- with .Identifier }}
      {{- with T . }}
        {{- $name = . }}
      {{- end }}
    {{- end }}
    {{- $params := dict 
      "ctx" . 
      "name" $name 
      "attrs" $attrs 
      "page" $page 
    }}
    -->
    
    <!-- {{- if not .Children }} Simple menu item-->
    {{- partial "inline/menu/simple.html" $params }}
    <!-- {{ else }} menu item with sub pages -->
    {{- partial "inline/menu/parent.html" $params }}
    <!-- {{ end }} -->
  {{- end }}
{{- end }}

{{- define "partials/inline/menu/simple.html" }}
<!-- 
{{- $ctx := index . "ctx" }}
{{- $name := index . "name" }}
{{- $attrs := index . "attrs" }}
{{- $page := index . "page" }}
{{- $open := (eq $page $ctx.Page) }}
{{- $props := partial "get-attributes" $attrs }}
{{ with $ctx }}
-->
<li>  
  <a
  {{ $props | safeHTMLAttr }}
  class="flex items-center p-2 text-gray-900 dark:text-white hover:bg-gray-100 dark:hover:bg-gray-700 group"
  :class="{
    'font-bold': '{{ $attrs.class }}' == 'active',
    'font-bold': {{ $open | jsonify }}
  }"  
  >
    <span class="w-6 text-xl text-center">{{ .Pre }}</span>
    <span class="ml-2">{{ $name }}</span>
  </a>      
</li>
<!-- {{ end }} -->
{{- end }}



{{- define "partials/inline/menu/parent.html" }}
<!-- 
{{- $ctx := index . "ctx" }}
{{- $name := index . "name" }}
{{- $attrs := index . "attrs" }}
{{- $page := index . "page" }}
{{- $open := partial "is-open" . }}
{{- $props := partial "get-attributes" $attrs }}
{{ with $ctx }}
-->
<li x-data="{ open: {{ $open | jsonify }} }">
  <a 
    {{ $props | safeHTMLAttr }}
    class="flex items-center w-full p-2 text-gray-900 dark:text-white hover:bg-gray-100 dark:hover:bg-gray-700 group"
    :class="{
      'font-bold': {{ (eq $page .Page) | jsonify }}
    }"   
  >
    <span class="w-6 text-xl text-center" @click.prevent="open = !open">{{ .Pre }}</span>
    <span class="ml-2 flex-1 text-left">{{ $name }}</span>
    <span class="p-2" @click.prevent="open = !open">
      <svg class="w-3 h-3" aria-hidden="true" xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 10 6">
          <path stroke="currentColor" stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="m1 1 4 4 4-4"/>
      </svg>
    </span>
  </a>
  <ul x-cloak x-show="open" class="space-y-2 border-y border-gray-500/15">
    {{- partial "inline/menu/walk.html" (dict "page" $page "menuEntries" .Children) }}
  </ul>
</li>
<!-- {{ end }} -->
{{- end }}

<!--
{{ define "partials/is-open" }}
{{- $ctx := index . "ctx" }}
{{- $page := index . "page" }}
{{- $open := (eq $page $ctx.Page) }}

{{- if and (not $open) ($page.Parent) }}
  {{- $open = partial "is-open" (dict "ctx" $ctx "page" $page.Parent ) }}
{{ end }}
{{ return $open }}
{{ end }}
-->

<!--
{{ define "partials/get-attributes" }}
{{ $params := "" }}
{{- range $k, $v := . }}
{{- if and $v (ne $k "class") }}
  {{- $param := printf "%s=%q" $k $v }}
  {{- $params = printf "%s %s" $params $param }}
{{- end }}
{{- end -}}
{{ return $params }}
{{ end }}
-->